Subject: Re: help: bisect single file from repos

From: walter harms <[email-masked]>
Date: Tue, 08 Dec 2009 14:41:42 +0100

Christian Couder schrieb:
> Hi,
> 
> On lundi 07 décembre 2009, walter harms wrote:
>> Michael J Gruber schrieb:
>>> walter harms venit, vidit, dixit 07.12.2009 13:59:
>>>> Hi list,
>>>> i am new to git (using: git version 1.6.0.2).
>>> though your git is not that new ;)
>>>
>>>> I would like to bisect a single file but i have only commit id, no
>>>> tags.
>>>>
>>>> Background:
>>>> I have a copy of the busybox git repos, and i know there is (perhaps)
>>>> a bug in ash.c.
>>>>
>>>> how can i do that ?
>>> You don't need any tags for bisecting. The man page of git-bisect has
>>> several examples on how to use it. Do you have a test script which
>>> exposes the bug?
>> unfortunately no, the error shows up very nicely when booting my
>> embdedded system but not else (this is the reason i would to bisect that
>> file only and not busybox completely). And from the man pages i got the
>> impression that it is only possible the start with a tag.
> 
> The man page says:
> 
> git bisect start [<bad> [<good>...]] [--] [<paths>...]
> 
> and then:
> 
> "This command uses git rev-list --bisect to help drive the binary search 
> process to find which change introduced a bug, given an old "good" commit 
> object name and a later "bad" commit object name."

i am sorry, i am not familiar with git and when i am stating i am looking
for examples first. the examples in my man page are like
git bisect start v2.6.20-rc6 v2.6.20-rc4
there is nothing like:
git bisect start 6a87a68a6a8 65a76a8a68a7

I ASSUME that you can use tags like "v2.6.20-rc6" and commit-id like "6a87a68a6a8"
interchangeable but that was not clear from beginning.
BTW did you notice the sentence says "commit object name" not "commit id" ? when
you are starting you are not familiar with the wording so you do not make the connection.

>> i already had the hint that i need to do:
>> git bisect start bad_commit_id good_commit_id -- ash.c
> 
> So did you try that?
> 

not yet, we are still using an older version of BB for production. So there is no hurry.
The problem is that we can not found the reason for the bug. NTL i plan for this week.

>> Ntl, there is one more question, how can i make sure that
>> i use the right version ?
> 
> If you mean the right git version, then I think any 1.6.X should be enough.
> 
>> first i toughed  that cherry-pick is the right 
>> idea but it seems that that will apply onyl certain patches ?
> 
> If you want to find the commit that introduced a bug, then you should not 
> need cherry-pick.
> 

mmh, no, the idea was to use something like

git "checkou" <id>  and having a version that represents THAT moment.

re,
 wh

> Regards,
> Christian.